unit Acrypt;
(** ================================= **)
(** Sourcesafe Unit Control Header **)
(** ================================= **)
(** $Archive: /Develop/1632/Shared DCUSRCE/encrypt.pas $ **)
(** $Revision: 4 $ **)
(** $Date: 26/05/96 16:56 $ **)
(** ================================= **)
(** Last Changed by                   **)
(** $Author: Gbamber $ **)
(** $Modtime: 19/05/96 23:50 $ **)
(** ================================= **)
(** $NoKeywords: $ **)
(** ================================= **)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,DsgnIntf;
Type tmode = (MODE_ENCRYPT,MODE_DECRYPT);

type
  TACRYPT = class(TComponent)
  private
    { Private declarations }
  FAbout      :	string;
  fkey        : string;
  foutput     : String;
  fInput      : String;
  fmode       : tmode;
  Function    GetKey :string;
  Procedure   SetKey(s_Value:string);
  Function    Getfoutput:String;
  Function    Getfinput :String;
  Procedure   Setfoutput(s_Value:String);
  Procedure   Setfinput(s_Value:String);

  protected
    { Protected declarations }
  function Prot_Encrypt(const Src,Key : String): String;
  function Prot_Decrypt(const Src,Key : String): String;

  public
    { Public declarations }
  procedure ShowAbout;Virtual;
  Constructor Create(AOwner:TComponent);override;
  Procedure Loaded;override;
  Function Encrypt(s_String:String):String;
  Function Decrypt(s_String:String):String;

  published
    { Published declarations }
  property About: string read FAbout write FAbout stored False;
  Property Key:string read GetKey write SetKey stored false;
  Property InString:String read getfinput write setfinput stored false;
  Property OutString:String read getfoutput write setfoutput stored False;
  Property Mode:tmode Read fmode write fmode stored False;
  end;

procedure Register;

(**) implementation (**)

(******************************************************************************)
(******************************************************************************)

type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue:string; override;
  end;

procedure Register;
begin
  RegisterComponents('Misc', [TACRYPT]);
  {register the 'About' property editor}
  RegisterPropertyEditor(TypeInfo(String), TACRYPT, 'About',
  	TAboutProperty);
end;
{########################################################################}
procedure TAboutProperty.Edit;
{call the 'About' dialog window when clicking on ... in the Object Inspector}
begin
  TACRYPT(GetComponent(0)).ShowAbout;
end;
function TAboutProperty.GetAttributes: TPropertyAttributes;
{set up to display a string in the Object Inspector}
begin
  GetAttributes := [paDialog, paReadOnly];
end;
function TAboutProperty.GetValue: String;
{set string to appear in the Object Inspector}
begin
  GetValue := '(About)';
end;
procedure TACRYPT.ShowAbout;
var
	msg: string;
const
  cr = chr(13);
begin
  msg := 'TACRYPT:' + ' a 16/32-Bit component' + cr;
  {$IFDEF WIN32}
  msg := msg + '(32 bit version)' + cr + cr;
  {$ELSE}
  msg := msg + '(16 bit version)' + cr + cr;
  {$ENDIF}
  msg := msg + 'Original Tencrypt Unit:' + cr;
  msg := msg + 'Copyright 1996 Gordon Bamber' + cr;
  msg := msg + 'Email: gbamber@mistral.co.uk' + cr + cr;
  msg := msg + 'This Tacrypt Unit is a' + cr;
  msg := msg + 'Tencrypt Hack (with permission)' + cr;
  msg := msg + 'By Jonathan Farley September 1996' + cr + cr;
  msg := msg + 'Waaaa I need coffee!!!@"*!';
  MessageDlg(msg,mtInformation,[MBOK],0);
end;
{########################################################################}

(******************************************************************************)

Function TACRYPT.GetKey;
begin
     Result:=fKey;
end;

(******************************************************************************)

Procedure TACRYPT.SetKey(s_Value:String);
begin
     if fkey <> s_Value then
      begin
        fkey:=s_Value;
        getfoutput;
      end;
end;

(******************************************************************************)

function TACRYPT.Prot_Encrypt(const Src,key: String): String;
var
   KeyLen    : Integer;
   KeyPos    : Integer;
   offset    : Integer;
   dest      : string;
   SrcPos    : Integer;
   SrcAsc    : Integer;
   TmpSrcAsc : Integer;
   Range     : Integer;
begin
     dest:='';
     KeyLen:=Length(Key);
     KeyPos:=0;
     SrcPos:=0;
     SrcAsc:=0;
     Range:=256;
{************************************************************************}
{              Change this number to customize your component            }
{************************************************************************}

     RANDSEED := 21890;

{************************************************************************}
{              This must match the random seed below                     }
{************************************************************************}

     offset:=Random(Range);
          dest:=format('%1.2x',[offset]);
          for SrcPos := 1 to Length(Src) do
          begin
               SrcAsc:=(Ord(Src[SrcPos]) + offset) MOD 255;
               if KeyPos < KeyLen then KeyPos:= KeyPos + 1 else KeyPos:=1;
               SrcAsc:= SrcAsc xor Ord(Key[KeyPos]);
               dest:=dest + format('%1.2x',[SrcAsc]);
               offset:=SrcAsc;
          end;
    result := dest;
end;

(******************************************************************************)

function TACRYPT.Prot_Decrypt(const Src,key : String): String;
var
   KeyLen    : Integer;
   KeyPos    : Integer;
   offset    : Integer;
   dest      : string;
   SrcPos    : Integer;
   SrcAsc    : Integer;
   TmpSrcAsc : Integer;
   Range     : Integer;
begin
     dest:='';
     KeyLen:=Length(Key);
     KeyPos:=0;
     SrcPos:=0;
     SrcAsc:=0;
     Range:=256;
{************************************************************************}
{              Change this number to customize your component            }
{************************************************************************}

     RANDSEED := 21890;

{************************************************************************}
{              This must match the random seed above                     }
{************************************************************************}
     offset:=StrToInt('$'+ copy(src,1,2));
          SrcPos:=3;
          repeat
                SrcAsc:=StrToInt('$'+ copy(src,SrcPos,2));
                if KeyPos < KeyLen Then KeyPos := KeyPos + 1 else KeyPos := 1;
                TmpSrcAsc := SrcAsc xor Ord(Key[KeyPos]);
                if TmpSrcAsc <= offset then
                     TmpSrcAsc := 255 + TmpSrcAsc - offset
                else
                     TmpSrcAsc := TmpSrcAsc - offset;
                dest := dest + chr(TmpSrcAsc);
                offset:=srcAsc;
                SrcPos:=SrcPos + 2;
          until SrcPos >= Length(Src);
       result := dest;
end;

(******************************************************************************)

Function TACRYPT.Encrypt(s_String:String):String;
begin
        Result:=Prot_Encrypt(s_String,fKey)

end;

(******************************************************************************)

Function TACRYPT.Decrypt(s_String:String):String;
begin
     Result:=Prot_Decrypt(s_String,fKey);
end;

(******************************************************************************)

Function TACRYPT.Getfoutput:String;
begin
    if fmode=MODE_ENCRYPT then
       Result:=Encrypt(finput)
    else
       Result:=Decrypt(finput);

end;

(******************************************************************************)

Function TACRYPT.Getfinput:String;
Begin
     Result:=finput;
end;

(******************************************************************************)

Procedure TACRYPT.Setfoutput(s_Value:String);
begin
     if s_Value <> foutput then foutput:=Getfoutput;
end;

(******************************************************************************)

Procedure TACRYPT.Setfinput(s_Value:String);
begin
     if s_value <> finput then
       begin
         finput:=s_Value;
         GetfOutPut;
       end;
end;

(******************************************************************************)

Procedure TACRYPT.Loaded;
begin
     Inherited Loaded;
     fmode:=MODE_ENCRYPT;
     finput:='Anystring';
     fKey:='Anykey';
     Getfoutput;
end;

(******************************************************************************)

Constructor TACRYPT.Create(AOwner:TComponent);
begin
     Inherited Create(AOwner);
     fmode:=MODE_ENCRYPT;
     finput:='Anystring';
     fKey:='Anykey';
     Getfoutput;
end;

(******************************************************************************)

end.
