unit Encrypt;
(** ================================= **)
(** Sourcesafe Unit Control Header **)
(** ================================= **)
(** $Archive: /Develop/1632/Shared DCUSRCE/encrypt.pas $ **)
(** $Revision: 4 $ **)
(** $Date: 26/05/96 16:56 $ **)
(** ================================= **)
(** Last Changed by                   **)
(** $Author: Gbamber $ **)
(** $Modtime: 19/05/96 23:50 $ **)
(** ================================= **)
(** $NoKeywords: $ **)
(** ================================= **)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,DsgnIntf;
Type tmode = (MODE_ENCRYPT,MODE_DECRYPT);

type
  TENCRYPT = class(TComponent)
  private
    { Private declarations }
  FAbout:	string;
  fkey:Word;
  foutput:String;
  fInput:String;
  fmode:tmode;
  Function GetKey:Word;
  Procedure SetKey(w_Value:Word);
  Function Getfoutput:String;
  Function Getfinput:String;
  Procedure Setfoutput(s_Value:String);
  Procedure Setfinput(s_Value:String);

  protected
    { Protected declarations }
  function Prot_Encrypt(const S: String; Key: Word): String;
  function Prot_Decrypt(const S: String; Key: Word): String;

  public
    { Public declarations }
  procedure ShowAbout;Virtual;
  Constructor Create(AOwner:TComponent);override;
  Procedure Loaded;override;
  Function Encrypt(s_String:String):String;
  Function Decrypt(s_String:String):String;

  published
    { Published declarations }
  property About: string read FAbout write FAbout stored False;
  Property Key:Word read GetKey write SetKey stored false;
  Property InString:String read getfinput write setfinput stored false;
  Property OutString:String read getfoutput write setfoutput stored False;
  Property Mode:tmode Read fmode write fmode stored False;
  end;

procedure Register;

(**) implementation (**)

(******************************************************************************)
(******************************************************************************)
type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue:string; override;
  end;

procedure Register;
begin
  RegisterComponents('Maxim', [TENCRYPT]);
  {register the 'About' property editor}
  RegisterPropertyEditor(TypeInfo(String), TENCRYPT, 'About',
  	TAboutProperty);
end;
{########################################################################}
procedure TAboutProperty.Edit;
{call the 'About' dialog window when clicking on ... in the Object Inspector}
begin
  TENCRYPT(GetComponent(0)).ShowAbout;
end;
function TAboutProperty.GetAttributes: TPropertyAttributes;
{set up to display a string in the Object Inspector}
begin
  GetAttributes := [paDialog, paReadOnly];
end;
function TAboutProperty.GetValue: String;
{set string to appear in the Object Inspector}
begin
  GetValue := '(About)';
end;
procedure TENCRYPT.ShowAbout;
var
	msg: string;
const
  cr = chr(13);
begin
  msg := 'TENCRYPT:' + ' a 16/32-Bit component' + cr;
  {$IFDEF WIN32}
  msg := msg + '(32 bit version)' + cr + cr;
  {$ELSE}
  msg := msg + '(16 bit version)' + cr + cr;
  {$ENDIF}
  msg := msg + 'Copyright 1996 Gordon Bamber' + cr;
  msg := msg + 'Email: gbamber@mistral.co.uk' + cr;
  MessageDlg(msg,mtInformation,[MBOK],0);
end;
{########################################################################}

(******************************************************************************)

Function TENCRYPT.GetKey;
begin
     Result:=fKey;
end;

(******************************************************************************)

Procedure TENCRYPT.SetKey(w_Value:Word);
begin
     if fkey <> w_Value then
      begin
        fkey:=w_Value;
        getfoutput;
      end;
end;

(******************************************************************************)

function TENCRYPT.Prot_Encrypt(const S: String; Key: Word): String;
const
  C1 = 52845;
  C2 = 22719;
var
  I: byte;
begin
  {$IFDEF WIN32}
  SetLength(Result,Length(S));
  {$ELSE}
  Result[0] := S[0];
  {$ENDIF}
  for I := 1 to Length(S) do begin
    Result[I] := char(byte(S[I]) xor (Key shr 8));
    Key := (byte(Result[I]) + Key) * C1 + C2;
  end;
end;

(******************************************************************************)

function TENCRYPT.Prot_Decrypt(const S: String; Key: Word): String;
const
  C1 = 52845;
  C2 = 22719;
var
  I: byte;
begin
  {$IFDEF WIN32}
  SetLength(Result,Length(S));
  {$ELSE}
  Result[0] := S[0];
  {$ENDIF}
  for I := 1 to Length(S) do begin
    Result[I] := char(byte(S[I]) xor (Key shr 8));
    Key := (byte(S[I]) + Key) * C1 + C2;
  end;
end;

(******************************************************************************)

Function TENCRYPT.Encrypt(s_String:String):String;
begin
        Result:=Prot_Encrypt(s_String,fKey)

end;

(******************************************************************************)

Function TENCRYPT.Decrypt(s_String:String):String;
begin
     Result:=Prot_Decrypt(s_String,fKey);
end;

(******************************************************************************)

Function TENCRYPT.Getfoutput:String;
begin
    if fmode=MODE_ENCRYPT then
       Result:=Encrypt(finput)
    else
       Result:=Decrypt(finput);

end;

(******************************************************************************)

Function TENCRYPT.Getfinput:String;
Begin
     Result:=finput;
end;

(******************************************************************************)

Procedure TENCRYPT.Setfoutput(s_Value:String);
begin
     if s_Value <> foutput then foutput:=Getfoutput;
end;

(******************************************************************************)

Procedure TENCRYPT.Setfinput(s_Value:String);
begin
     if s_value <> finput then
       begin
         finput:=s_Value;
         GetfOutPut;
       end;
end;

(******************************************************************************)

Procedure TENCRYPT.Loaded;
begin
     Inherited Loaded;
     fmode:=MODE_ENCRYPT;
     finput:='anystring';
     fKey:=1234;
     Getfoutput;
end;

(******************************************************************************)

Constructor TENCRYPT.Create(AOwner:TComponent);
begin
     Inherited Create(AOwner);
     fmode:=MODE_ENCRYPT;
     finput:='anystring';
     fKey:=1234;
     Getfoutput;
end;

(******************************************************************************)

end.
